Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 3.3.2   

Resolution: Fixed Affected version: 3.3.1

Description

Issue

1. Editing the Project Field in an Issue reloads the form

2. On Reloading / Rendering the project field is excluded if the user is not allowed to change the project_id for issues in that

project

3. The field disappears when the user clicks on a project where changing the project field is not allowed

4. The issue cannot be moved to the other project by that user, however: The list of target projects is calculated by the right to

create issues in that project. This means that there is a mismatch.

Goal

The project field should not disappear on selection of a project, either by showing the field more often (lax approach) or reducing the

target projects list.

Suggestion

My suggestion for the lax approach is:

# app/views/issues/_form.html.erb

- <% if @issue.safe_attribute?('project_id') && (!@issue.new_record? || @project.nil? || @issue.co

py?) %>

+ <% if (@issue.safe_attribute?('project_id') || @issue.allowed_target_projects.include?(@issue.pr

oject_id) ) && (!@issue.new_record? || @project.nil? || @issue.copy?) %>

  <p><%= f.select :project_id, project_tree_options_for_select(@issue.allowed_target_projects, :se

lected => @issue.project), {:required => true},

                  :onchange => "updateIssueFrom('#{escape_javascript update_issue_form_path(@proje

ct, @issue)}', this)" %></p>

  <% end %>

Associated revisions

Revision 15959 - 2016-11-18 12:56 - Jean-Philippe Lang

Project field disappears when target project disallows user to edit the project (#24311).

Revision 16047 - 2016-12-03 09:42 - Jean-Philippe Lang

Merged r15959 (#24311).

History

#1 - 2016-11-11 11:32 - Luka Lüdicke

- File issues_form.diff added

#2 - 2016-11-18 12:57 - Jean-Philippe Lang

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Target version set to 3.3.2
- Resolution set to Fixed

Fixed in r15959 using a slightly different solution and tests added.

Thanks for pointing this out.

#3 - 2016-12-03 09:42 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Files

issues_form.diff 802 Bytes 2016-11-11 Luka Lüdicke
